#! /bin/sh
# vmgen.  Generated from vmgen.in by configure.
#Copyright (C) 2001,2002,2003,2007,2008 Free Software Foundation, Inc.

#This file is part of Gforth.

#Gforth is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation, either version 3
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.#See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, see http://www.gnu.org/licenses/.

prefix=/usr
test "x$GFORTHDIR" != x || GFORTHDIR=${prefix}/bin
test "x$GFORTHDATADIR" != x || GFORTHDATADIR=$prefix/share/gforth/0.7.3
GFORTH=$GFORTHDIR/gforth-fast
if test $# = 0 || test $1 = --help || test $1 = -h; then
  echo "usage: `basename $0` <file>.vmg"
  exit 0
elif test $1 = --version || test $1 = -v; then
  echo "vmgen (gforth) 0.7.3"
  $GFORTH --version
  echo 'Copyright (C) 2001,2002,2003,2007,2008 Free Software Foundation, Inc.'
  echo 'This program is part of Gforth'
  $GFORTH -e "license bye"
  exit 0
else
    true #old shells require this
fi
if grep -q vmgen-version $1; then
    version=`grep vmgen-version $1|sed 's/^.*vmgen-version //'`
else
    version=0.6.2
fi
prims2x=$GFORTHDATADIR/prims2x$version.fs
file=`basename $1 .vmg`
$GFORTH -m 1000000 -e "create vmgen" $prims2x -e "c-flag on s\" $file-vm.i\" out-filename 2! s\" $1\" ' output-c ' output-c-combined process-file bye" > $file-vm.i &&
$GFORTH -m 1000000 -e "create vmgen" $prims2x -e "c-flag on s\" $1\" ' output-disasm dup process-file bye" > $file-disasm.i &&
$GFORTH -m 1000000 -e "create vmgen" $prims2x -e "c-flag on s\" $1\" ' output-gen ' noop process-file bye" > $file-gen.i &&
$GFORTH -m 1000000 -e "create vmgen" $prims2x -e "c-flag on s\" $1\" ' output-label dup process-file bye" > $file-labels.i &&
$GFORTH -m 1000000 -e "create vmgen" $prims2x -e "c-flag on s\" $1\" ' output-profile dup process-file bye" > $file-profile.i &&
$GFORTH -m 1000000 -e "create vmgen" $prims2x -e "c-flag on s\" $1\" ' noop ' output-peephole process-file bye" > $file-peephole.i
